//
// Created by 11067 on 2023/6/27.
//

#ifndef COMPILER_ABLOCK_H
#define COMPILER_ABLOCK_H
#include "../../utils/LinkedList.h"
#include "AInstr.h"
#include <string>
namespace armv7 {
    struct ABlock;
    struct AJTable{
        std::string label{};
        ABlock *from{};
        ABlock *exitBranch{};
        AReg switchReg{};
        std::vector<std::pair<int, ABlock*>> to{};
        void toAssemblyString(std::ostream& out) const;
    };
    struct ABlock: public atri::LinkedNode<ABlock>, public atri::LinkedContainer<AInstr>{
        std::string label;

        std::unordered_set<ABlock*> prec{};
        std::unordered_set<ABlock*> succ{};
        std::vector<AReg> liveIn{};
        std::vector<AReg> liveOut{};
        std::vector<AReg> def{};
        std::vector<AReg> use{};

        ABlock* succBranch{nullptr};
        ABlock* failBranch{nullptr};
        int trailingLTORG{0}; // ltorg大小，单位4B
        std::vector<unsigned int> myLiteralPool;
        int loopDepth{};
        bool aligned{false}; // 是否quadword对齐 .align 4

        AJTable *ajTable{nullptr}; //后面是否挂跳转表

        explicit ABlock(std::string label);

        void toAssemblyString(std::ostream& out);

        size_t getInstrCntNoComment();
    };

} // armv7

#endif //COMPILER_ABLOCK_H
