//
// Created by 11067 on 2023/6/29.
//

#ifndef COMPILER_ACOMPILEUNIT_H
#define COMPILER_ACOMPILEUNIT_H

#include "../../utils/LinkedList.h"
#include "AFunction.h"
#include "AData.h"
#include <vector>
namespace armv7 {

    struct ACompileUnit: atri::LinkedContainer<AFunction> {
        std::vector<AData*> data;
        std::vector<AData*> bss; // 初始化为0的全局数据
        std::vector<std::string> supportFunctions;
        std::vector<std::string> funcTemplate; // 汇编模板
        std::unordered_set<std::string> atriBuiltinName;
        bool genAtriBuiltin{false};
        ACompileUnit();

        std::string toAssemblyString();
    };

} // armv7

#endif //COMPILER_ACOMPILEUNIT_H
