//
// Created by 11067 on 2023/6/28.
//

#ifndef COMPILER_ADATA_H
#define COMPILER_ADATA_H
#include <string>
#include <vector>
#include <variant>

namespace armv7 {
    /**
     * variant 若为int表示插入几个0
     */
    typedef std::variant<
            std::vector<int>,
            int
    > IntOrZero;
    /**
     * variant 若为int表示插入几个0
     */
    typedef std::variant<
            std::vector<float>,
            int
    > FloatOrZero;

    struct AData {
        std::string label;
        std::variant<
            std::vector<IntOrZero>,
            std::vector<FloatOrZero>
        > data;

        void toAssemblyString(std::ostream& out) const;

    };

//    /**
//     * @brief 用于存储离散数据，处理其中有很多0的情况。
//     */
//    struct ASparseData {
//        std::string label;
//        std::vector<DataOrZero> data;
//        void toAssemblyString(std::ostream& out) const;
//    };

    AData * makeADataInt(const std::string& label, const std::vector<int>& array);
    AData * makeADataFloat(const std::string& label, const std::vector<float>& array);
    AData *makeADataFloatZeroed(const std::string& label, int s);
    AData *makeADataIntZeroed(const std::string &label, int s);

} // armv7

#endif //COMPILER_ADATA_H
