//
// Created by 11067 on 2023/6/27.
//

#ifndef COMPILER_AFUNCTION_H
#define COMPILER_AFUNCTION_H

#include "ABlock.h"
#include "instructions/AInstrLS.h"
#include "instructions/AInstrPseudo.h"

namespace armv7 {

    struct AFunction: public atri::LinkedNode<AFunction>, public atri::LinkedContainer<ABlock>{
        std::string label;
        bool isLib{false};
        int vRegAllocated = 0; //已分配的虚拟寄存器数量
        std::vector<VReg::Type> vRegType{}; //分配的虚拟寄存器的类型
        int stackArrayAllocated = 0; //已分配栈上数组占用了stackArrayAllocated * 4B
        // 函数中加载参数的指令，因为没有使用fp(bp)，局部变量使用的栈大小未知，这些指令可能需要重写
        std::vector<AInstrLS *> loadParamInstructions{};
        std::vector<AInstrAddRImmPse *> loadLocalArrayInstructions{};
        AInstrSpAdd * reserveLocal; //因为在寄存器分配前不知道使用了多少栈，这两条指令需要回填
        AInstrSpAdd * cleanLocal;
        explicit AFunction(std::string label);

        void toAssemblyString(std::ostream &out);

        bool checkPrecSucc();

        void calcPrecSucc();
    };


} // armv7

#endif //COMPILER_AFUNCTION_H
