//
// Created by 11067 on 2023/6/26.
//

#include "common.h"

using namespace std::literals;
namespace armv7 {
    std::string operand2ToString(Operand2 operand2) {
        if (std::holds_alternative<int>(operand2)) {
            int &num = std::get<int>(operand2);
            if (!isImm8m(num)) {
                error(num, "is not imm8m");
            }
            return "#"s + std::to_string(num);
        } else {
            auto &reg = std::get<Operand2Reg>(operand2);
            if (reg.shiftType == ShiftType::None) {
                return aReg2String(reg.base);
            }
            if (std::holds_alternative<int>(reg.shift)) {
                int &shift = std::get<int>(reg.shift);
                return aReg2String(reg.base) + ", " + shiftType2CStr(reg.shiftType) + " #" + std::to_string(shift);
            } else {
                AReg &shift = std::get<AReg>(reg.shift);
                return aReg2String(reg.base) + ", " + shiftType2CStr(reg.shiftType) + ' ' + aReg2String(shift);
            }
        }
    }
} // armv7