//
// Created by 11067 on 2023/8/2.
//

#ifndef COMPILER_PEEPHOLE_H
#define COMPILER_PEEPHOLE_H

#include "APass.h"

namespace armv7 {

    class Peephole : public APass {
    public:
        void run(ACompileUnit &compileUnit) override;

        void runOnFunction(AFunction *function);

        /**
         * @brief 清除注释
         * @param function
         */
        void cleanupComment(AFunction *function);

        /**
         * @brief 如果无条件跳转到下一个紧邻的块，这个跳转可以删除
         * 注意这个优化打破了基本块尾部跳转的结构，应该放在后面
         * @param function
         */
        void redundantJump(AFunction *function);

        /**
         * @brief 通过移动一些块，消除更多无条件跳转
         * @param function
         */
        void blockReorder(AFunction *function);

        /**
         * @brief 最普通的窥孔
         * @param function
         */
        void trivPeephole(AFunction *function);
    };

} // armv7

#endif //COMPILER_PEEPHOLE_H
