//
// Created by 11067 on 2023/6/25.
//

#ifndef COMPILER_MCCOMPILEUNIT_H
#define COMPILER_MCCOMPILEUNIT_H

#include "../../utils/LinkedList.h"
#include "../../utils/bitUtils.h"
#include "arch.h"
#include "MCFunction.h"
#include "MCBlock.h"
#include "MCData.h"
#include <vector>
#include "../../optimization/ir.h"
namespace riscv {
struct MCFunction;
struct MCCompileUnit : public atri::LinkedContainer<MCFunction> {
//    std::vector<MInstr> prelude; // 在进入主函数之前执行的代码
//    std::vector<MCData *> data;    // 全局数据
    std::unordered_map<Ir::Type*, MCData*> globalVarMap{};
    std::unordered_map<std::string, MCData*> globalVecNameMap{};
    std::vector<std::string> supportFunctions;
    std::unordered_set<double> float_nums;
    int block_num;
    std::unordered_set<std::string> atriBuiltinName;
    bool genAtriBuiltin{false};
    explicit MCCompileUnit(Ir::CompileUnit &ir);
    void gen_global_var(std::ostream &out);
    void gen_ro_data(std::ostream &out);
    void gen_asm(std::ostream &out);
    void reg_alloc();
    void foreOPT();
    void afterOPT();
    void clear();
};
} // namespace riscv

#endif // COMPILER_MCCOMPILEUNIT_H
