//
// Created by 11067 on 2023/5/22.
//

#ifndef ATRI_BACKEND_MCDATA_H
#define ATRI_BACKEND_MCDATA_H
#include <string>
#include <utility>
#include <variant>
#include <vector>
namespace riscv {
/**
 * variant 若为int表示插入几个0
 */
typedef std::variant<
    std::vector<int>,
    int>
    IntOrZero;
/**
 * variant 若为int表示插入几个0
 */
typedef std::variant<
    std::vector<float>,
    int>
    FloatOrZero;

struct MCData {
    std::string label;
    std::variant<
        std::vector<IntOrZero>,
        std::vector<FloatOrZero>>
        data;
    MCData(std::string _label, std::variant<
                                   std::vector<IntOrZero>,
                                   std::vector<FloatOrZero>>
                                   _data):label(std::move(_label)), data(std::move(_data)){}
};
MCData *makeMCDataInt(const std::string &label, const std::vector<int> &array);
MCData *makeMCDataFloat(const std::string &label, const std::vector<float> &array);
MCData *makeMCDataFloatZeroed(const std::string &label, int s);
MCData *makeMCDataIntZeroed(const std::string &label, int s);

} // namespace riscv

#endif // ATRI_BACKEND_MCDATA_H
