//
// Created by MSI-NB on 2023/7/30.
//

#ifndef COMPILER_MOPTIMIZOR_H
#define COMPILER_MOPTIMIZOR_H

#include "./MCCompileUnit.h"
#include "./MRInstr.h"
#include "./instructions/MCalInstr.h"
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <sstream>
#include <valarray>

using std::set;
using std::unordered_set;
using std::vector;
namespace riscv {
struct MCBlock;
struct MCFunction;
struct MCCompileUnit;
class MOptimizer {
    MCFunction *function;
    void moveBlock();
    void mergeBlock();
    void dce();
    void mergeInstr();
    void forePeepHole();
    void afterPeepHole();
    void delEmptyBlk();

    vector<Reg> getDef(MRInstr *instr);
    vector<Reg> getUse(MRInstr *instr);
public:
    MOptimizer(MCFunction * _function);
    void foreOPT();
    void afterOPT();
};
} // namespace riscv

#endif // COMPILER_MOPTIMIZOR_H
