//
// Created by MSI-NB on 2023/7/6.
//

#ifndef COMPILER_MRINSTR_H
#define COMPILER_MRINSTR_H

#include "../../utils/LinkedList.h"
#include "../../utils/bitUtils.h"
#include "../../optimization/ir.h"
#include "arch.h"
#include <utility>
#include <vector>
#include <string>
#include <set>

namespace riscv {

struct MRInstr : atri::LinkedNode<MRInstr> {
    Reg op1;
    Reg op2;
    Reg op3;

    MRInstr() = default;
    virtual ~MRInstr() = default;
    virtual void gen_asm(std::ostream &out) = 0;
    Reg *get_op1() {
        return &op1;
    }
    Reg *get_op2() {
        return &op2;
    }
    Reg *get_op3() {
        return &op3;
    }
};

} // namespace riscv

#endif // COMPILER_MRINSTR_H
