//
// Created by MSI-NB on 2023/7/6.
//

#include "MCondJumpInstr.h"
namespace riscv {
void riscv::GotoInstr::gen_asm(std::ostream &out) {
    out << "j " << target->label << "\n";
}
void riscv::IfConInstr::gen_asm(std::ostream &out) {
    if (op2.isConst) {
        if (op2.int_num != 0) {
            out << "j " << target->label << "\n";
        }
    } else {
        out << "bnez " << op2 << ", " << target->label << "\n";
    }
}
void riscv::IfNotInstr::gen_asm(std::ostream &out) {
}
void riscv::LabelInstr::gen_asm(std::ostream &out) {
}

GotoInstr::GotoInstr(MCBlock *_target) {
    this->target = _target;
}

IfConInstr::IfConInstr(MCBlock *target, const Reg &_op2) {
    this->target = target;
    op2 = _op2;
}

IfNotInstr::IfNotInstr(std::string label, const Reg &_op2) {
    this->label = std::move(label);
    op2 = _op2;
}
} // namespace riscv
