//
// Created by MSI-NB on 2023/7/6.
//

#ifndef COMPILER_MCONDJUMPINSTR_H
#define COMPILER_MCONDJUMPINSTR_H

#include <utility>
#include "../MCBlock.h"
#include <variant>
#include "../MRInstr.h"

namespace riscv {
struct MCBlock;
struct GotoInstr : MRInstr {
    MCBlock *target;
    explicit GotoInstr(MCBlock * _target);
    void gen_asm(std::ostream &out) override;
};

struct IfConInstr : MRInstr {
    MCBlock *target;
    IfConInstr(MCBlock *target, const Reg &_op2);
    void gen_asm(std::ostream &out) override;
};

struct IfNotInstr : MRInstr {
    std::string label;
    IfNotInstr(std::string label, const Reg &_op2);
    void gen_asm(std::ostream &out) override;
};

struct LabelInstr : MRInstr {
    std::string label;
    explicit LabelInstr(std::string label) :
        label(std::move(label)){};
    void gen_asm(std::ostream &out) override;
};
} // namespace riscv

#endif // COMPILER_MCONDJUMPINSTR_H
