//
// Created by MSI-NB on 2023/7/6.
//

#include "MFuncInstr.h"
namespace riscv {
void riscv::CallInstr::gen_asm(std::ostream &out) {
    out << "call " << label << "\n";
}
void riscv::ParaPushInstr::gen_asm(std::ostream &out) {
}

std::vector<Reg> CallInstr::get_def() {
    std::vector<Reg> ret;
    if(!is_void){
        ret.push_back(get_ret(is_float));
    }
    return ret;
}

std::vector<Reg> CallInstr::get_use() {
    std::vector<Reg> ret;
    for(int i=0;i<std::min(ARG_REG_NUM, int_arg_cnt);i++) {
        ret.push_back(get_reg_by_id(ARG_REGS[i]));
    }
    for(int i=0;i<std::min(ARG_REG_NUM, float_arg_cnt);i++) {
        ret.push_back(get_freg_by_id(ARG_REGS[i]));
    }
    return ret;
}

void riscv::RetureInstr::gen_asm(std::ostream &out) {
    if (!is_void) {
        if (op2.type == Ir::Int) {
            if (op2.isConst) {
                out << "li " << get_ret() << ", " << op2.int_num << "\n";
            } else {
                out << "mv " << get_ret() << ", " << op2 << "\n";
            }
        } else if (op2.type == Ir::Float) {
            out << "fmv.s " << get_ret(true) << ", " << op2 << "\n";
        } else {
            panic(false);
        }
    }
}
RetureInstr::RetureInstr(const Reg &_op2) {
    is_void = false;
    op2 = _op2;
}

RetureInstr::RetureInstr() {
    is_void = true;
}
} // namespace riscv
