//
// Created by MSI-NB on 2023/7/6.
//

#ifndef COMPILER_MFUNCINSTR_H
#define COMPILER_MFUNCINSTR_H

#include <utility>

#include "../MRInstr.h"

namespace riscv {
struct CallInstr : MRInstr {
    std::string label;
    bool is_void;
    bool is_float;
    int int_arg_cnt, float_arg_cnt;
    explicit CallInstr(std::string _label, bool _is_void, bool _is_float, int _int_arg_cnt, int _float_arg_cnt) :
        label(std::move(_label)),is_void(_is_void),is_float(_is_float),int_arg_cnt(_int_arg_cnt),float_arg_cnt(_float_arg_cnt){};
    std::vector<Reg> get_def();
    std::vector<Reg> get_use();
    void gen_asm(std::ostream &out) override;
};
// todo paradef 参数定义

struct ParaPushInstr : MRInstr {
    void gen_asm(std::ostream &out) override;
};

struct RetureInstr : MRInstr {
    bool is_void;
    explicit RetureInstr(const Reg &_op2);
    RetureInstr();
    void gen_asm(std::ostream &out) override;
};

} // namespace riscv

#endif // COMPILER_MFUNCINSTR_H
