//
// Created by MSI-NB on 2023/7/11.
//

#ifndef COMPILER_MPSEUDOINSTR_H
#define COMPILER_MPSEUDOINSTR_H

#include <utility>

#include "../MRInstr.h"
#include "../MCBlock.h"

namespace riscv {
struct MCBlock;
struct Reg;
struct ParaCopyInstr : MRInstr {
    std::vector<std::pair<Reg, Reg>> copy;
    void gen_asm(std::ostream &out) override;
};

struct PhiInstr: MRInstr {
    std::vector<std::pair<Reg,MCBlock*>> pairs;
    void gen_asm(std::ostream &out) override;
    explicit PhiInstr(const Reg& dest);
};

struct DebugInstr: MRInstr {
    std::string out_info{""};
    DebugInstr()= default;;
    DebugInstr(std::string _info):out_info(std::move(_info)){};
    void gen_asm(std::ostream &out) override;
};

} // namespace riscv
#endif // COMPILER_MPSEUDOINSTR_H
