////
//// Created by 11069 on 16/7/2023.
////
//// 此array ssa非彼 array ssa
//// 对每条访存指令(Load,Store,LoadGlobal,StoreGlobal,Call(函数可能访存)) 注明其访问的地址,和地址对应的变量
//// 读 是 MemRead,对应load系
//// 写 是 MemWrite,对应store系
//// 每一个MemRead,都有dst,addr,scope
//// 对每一个MemWrite,都有val,addr,scope
//// scope对应对应的变量
//// 比如 a[2] = ... 就是MemWrite val是右值,addr是a+2,scope是a
//// 可以认为是array ssa但是没有at,认为全部都更新了
//// 对于 phi 也需要新的 phi, array_phi,该phi bb 对应 ssa 的地址
//// 好处就是能很好并行不同地址的操作
//// gcm可以对访存指令进行移动,对不pure,但是只是访问了参数的,就可以motion
//// 可以认为是细粒度没这么大的array ssa,细粒度大了不好写,呜呜
//
//
// 此array ssa非彼 array ssa
// 对每条访存指令(Load,Store,LoadGlobal,StoreGlobal,Call(函数可能访存)) 注明其访问的地址,和地址对应的变量
// 读 是 MemRead,对应load系
// 写 是 MemWrite,对应store系
// 每一个MemRead,都有dst,addr,scope
// 对每一个MemWrite,都有val,addr,scope
// scope对应对应的变量
// 比如 a[2] = ... 就是MemWrite val是右值,addr是a+2,scope是a
// 可以认为是array ssa但是没有at,认为全部都更新了
// 对于 phi 也需要新的 phi, array_phi,该phi bb 对应 ssa 的地址
// 好处就是能很好并行不同地址的操作
// gcm可以对访存指令进行移动,对不pure,但是只是访问了参数的,就可以motion
// 可以认为是细粒度没这么大的array ssa,细粒度大了不好写,呜呜


#include "opt.h"
using namespace Ir;
namespace opt {

unordered_map<Function*,unordered_set<shared_ptr<Type>>> func_read_global;
unordered_map<Function*,unordered_set<shared_ptr<Type>>> func_write_global;
unordered_map<Function*,unordered_set<int>> func_write_param; // 装param id
unordered_map<Function*,unordered_set<int>> func_read_param; // 装param id
unordered_set<Function *> visited_func;

// 对于全局变量,就是reg就行了
// 对于参数,是vector类型的,会做转换,比如loadArray,转换成memobject 和 vector,这里要做操作,记录转换

void find_mem_write(Function* func) { // 记录每个函数对内存的读写操作,在mem2reg的时候对call指令进行拓展,方便记录内存变化然后gcm
    func_read_global[func]= {};
    func_read_param[func] = {};
    func_write_global[func] = {};
    func_write_param[func] = {};
    // 首先对参数进行初始化
    visited_func.insert(func);
    unordered_map<int,int> mem2scope; // 为-1表明是global,需要去mem2global到base id
    unordered_map<int, int> id2index;
    unordered_map<int, int> mem2global;
    unordered_map<int,shared_ptr<Vector>> mem2gVector;
    if(func->get_name() == "getarray" || func->get_name() == "getfarray") {
        func_read_param[func].insert(0);
        func_write_param[func].insert(0);
        return;
    }
    if(func->get_name() == "putarray" || func->get_name() == "putfarray") {
        func_read_param[func].insert(1);
        return;
    }

    if(func->get_name() == memset_func_name ) {
        func_read_param[func].insert(0);
        return;
    }

    int i = 0;
    for(auto &param:func->get_params()) {
        Instanceof(vector,Vector*,param.get()) {
            mem2scope[vector->get_id()] = vector->get_id();
            id2index[vector->get_id()] = i;
        }
        i++;
    }

    // 遍历指令,记录read,write
    for(auto&bb:func->get_bbs()) {
        for(auto&inst:bb->get_instrs()) {
            Instanceof(loadGlobal,LoadGlobal*,inst.get()) {
                func_read_global[func].insert(loadGlobal->get_addr());
            } else Instanceof(storeGlobal,StoreGlobal*,inst.get()) {
                func_read_global[func].insert(storeGlobal->get_addr());
                func_write_global[func].insert(storeGlobal->get_addr());
            } else Instanceof(loadArray,LoadArray*,inst.get()) {
                if(loadArray->get_addr()->get_id() < 0) { // 全局数组
                    mem2scope[loadArray->get_dst()->get_id()] = -1;
                    mem2gVector[loadArray->get_dst()->get_id()] = loadArray->get_addr();
                } else {
                    if(mem2scope.count(loadArray->get_addr()->get_id())) {
                      if(mem2scope[loadArray->get_addr()->get_id()] >= 0) { // 局部数组
                        mem2scope[loadArray->get_dst()->get_id()] =
                            mem2scope[loadArray->get_addr()->get_id()];
                      } else { // 全局数组
                        mem2scope[loadArray->get_dst()->get_id()] = -1;
                        mem2gVector[loadArray->get_dst()->get_id()] = mem2gVector[loadArray->get_addr()->get_id()];
                      }
                    }

                }
            } else Instanceof(load,LoadInstr*,inst.get()) {
                if(mem2scope.count(load->get_addr()->get_id())) {
                    if(mem2scope[load->get_addr()->get_id()] < 0) { // load 全局数组
                        func_read_global[func].insert(mem2gVector[load->get_addr()->get_id()]);
                    } else {
                        func_read_param[func].insert(id2index[mem2scope[load->get_addr()->get_id()]]);
                    }
                }
            } else Instanceof(loadVector,LoadVector*,inst.get()) {
                if(loadVector->get_addr()->get_id() < 0) { // 全局数组
                    mem2scope[loadVector->get_dst()->get_id()] = -1;
                    mem2gVector[loadVector->get_dst()->get_id()] = loadVector->get_addr();
                } else { // 局部数组
                    if(mem2scope.count(loadVector->get_addr()->get_id())) {
                        if(mem2scope[loadVector->get_addr()->get_id()] >= 0) { // 局部数组
                          mem2scope[loadVector->get_dst()->get_id()] =
                              mem2scope[loadVector->get_addr()->get_id()];
                        } else { // 全局数组
                          mem2scope[loadVector->get_dst()->get_id()] = -1;
                          mem2gVector[loadVector->get_dst()->get_id()] = mem2gVector[loadVector->get_addr()->get_id()];
                        }
                  }
                }
            } else Instanceof(store,StoreInstr*,inst.get()) {
                auto addr = store->get_addr();
                if(!mem2scope.count(addr->get_id()))
                    continue ;
                auto base_id = mem2scope[addr->get_id()];
                if(base_id >= 0) { // store param
                    func_write_param[func].insert(id2index[base_id]);
                    func_read_param[func].insert(id2index[base_id]);
                } else { // store global
                    auto vector = mem2gVector[addr->get_id()];
                    func_write_global[func].insert(vector);
                    func_read_global[func].insert(vector);
                }
            } else Instanceof(call,CallInstr*,inst.get()) {
                if(!visited_func.count(call->get_function())) {
                    find_mem_write(call->get_function());
                }

                func_read_global[func].insert(func_read_global[call->get_function()].begin(),func_read_global[call->get_function()].end());
                func_write_global[func].insert(func_write_global[call->get_function()].begin(),func_write_global[call->get_function()].end());
                //func_write_param[func].insert(func_write_param[call->get_function()].begin(),func_write_param[call->get_function()].end());
                //func_read_param[func].insert(func_read_param[call->get_function()].begin(),func_read_param[call->get_function()].end());
                for(auto &write_param:func_write_param[call->get_function()]) {
                    auto param = call->get_params()[write_param];
                    if(mem2scope.count(param->get_id())) {
                        if(param->get_id() >= 0) { // param read
                           if(mem2scope[param->get_id()] >= 0) { // 经过转换的param
                                func_write_param[func].insert(id2index[mem2scope[param->get_id()]]);
                                func_read_param[func].insert(id2index[mem2scope[param->get_id()]]);
                           } else { // 经过转换的global vector
                                func_write_global[func].insert(mem2gVector[param->get_id()]);
                                func_read_global[func].insert(mem2gVector[param->get_id()]);
                           }
                        } else { // global vector read
                            func_write_global[func].insert(param);
                            func_read_global[func].insert(param);
                        }
                    }
                }

                for(auto &read_param:func_read_param[call->get_function()]) {
                    auto param = call->get_params()[read_param];
                    if(mem2scope.count(param->get_id())) {
                        if(param->get_id() >= 0) { // param read
                            if(mem2scope[param->get_id()] >= 0) { // 经过转换的param
                                func_read_param[func].insert(id2index[mem2scope[param->get_id()]]);
                            } else { // 经过转换的global vector
                                func_read_global[func].insert(mem2gVector[param->get_id()]);
                            }
                        } else { // global vector read
                            func_read_global[func].insert(param);
                        }
                    }
                }
            }
        }
    }


}

void array_mem2reg(Function* func,CompileUnit *cu) {

    if (func->is_lib()) {
        return ;
    }

    func->cfg->build();
    func->cfg->dom_build();

    unordered_map<Type*, std::unordered_set<BasicBlock*>> defs; // vector and reg
    unordered_map<BasicBlock*,unordered_map<Type*,shared_ptr<Type>>> reachingDefs; // rename 使用,寻找addr对应的def place
    std::unordered_map<shared_ptr<Type>, Ir::BasicBlock*> alloca2bb;
    unordered_map<Type*,Type*> mem2scope;

    // 首先寻找所有的mem write
     auto entry = func->get_first_bb();
    for(auto &param:func->get_params()) {
        Instanceof(vector,Vector*,param.get()) {
            mem2scope[vector] = vector;
            alloca2bb[param] = entry;
            defs[vector].insert(entry);
            reachingDefs[entry][vector] = param;
        }
    }

    // 对于全局数组/变量,也要初始化一下
    for(auto &global_vector:func_read_global[func]) {
        mem2scope[global_vector.get()] = global_vector.get();
        defs[global_vector.get()].insert(entry);
        alloca2bb[global_vector] = entry;
        reachingDefs[entry][global_vector.get()] = global_vector;
    }

//    for(auto &global_vector:func_write_global[func]) {
//        mem2scope[global_vector.get()] = global_vector.get();
//        defs[global_vector.get()].insert(entry);
//        alloca2bb[global_vector] = entry;
//        reachingDefs[entry][global_vector.get()] = global_vector;
//    }

    // 遍历指令,寻找def

    for (const auto &bb : func->get_bbs()) {
        for (const auto &inst : bb->get_instrs()) { // 所有store,call,loadarray和loadvector
            Instanceof(alloc,AllocaInstr*,inst.get()) {
                Instanceof(vector,Vector*,alloc->get_addr().get()) {
                    mem2scope[vector] = vector;
                    alloca2bb[alloc->get_addr()] = bb.get();
                    defs[vector].insert(bb.get());
                    reachingDefs[bb.get()][alloc->get_addr().get()] = alloc->get_addr();
                }
            } else Instanceof(storeGlobal,StoreGlobal*,inst.get()) {
                defs[storeGlobal->get_addr().get()].insert(bb.get());
            } else Instanceof(loadVector,LoadVector*,inst.get()) {
                mem2scope[loadVector->get_dst().get()] = mem2scope[loadVector->get_addr().get()];
            } else Instanceof(loadArray,LoadArray*,inst.get()) {
                mem2scope[loadArray->get_dst().get()] = mem2scope[loadArray->get_addr().get()];
            } else Instanceof(store,StoreInstr*,inst.get()) {
                if(mem2scope.count(store->get_addr().get())) {
                    defs[mem2scope[store->get_addr().get()]].insert(bb.get());
                }
            } else Instanceof(call,CallInstr*,inst.get()) {
                for(auto &write_global:func_write_global[call->get_function()]) {
                    defs[mem2scope[write_global.get()]].insert(bb.get());
                }
                for(auto &write_param:func_write_param[call->get_function()]) {
                    auto param = call->get_params()[write_param];
                    defs[mem2scope[param.get()]].insert(bb.get());
                }
            }
        }
    }

    // first stage, phi-function insertion
    for (auto &pair : alloca2bb) {
        auto v = pair.first;

        std::unordered_set<Ir::BasicBlock *> F;
        std::unordered_set<Ir::BasicBlock *> W;
        for (auto &item : defs[v.get()]) {
            W.insert(item);
        }
        while (!W.empty()) {
            auto X = W.begin();
            bool dirty = false;
            for (auto &Y : (*X)->df) {
                if (!F.count(Y)) {
                    F.insert(Y);
                    shared_ptr<Type> dst;
                    Instanceof(vector,Vector*,v.get()) {
                        dst = Factory::get_vector(v->get_type());
                    } else Instanceof(reg,Reg*,v.get()) {
                        dst = Ir::Factory::get_reg(v->get_type());
                    }
                    auto *phi = new ArrayPhi(dst, v);
                    phi->set_belongto_bb(Y);
                    Y->get_instrs().emplace_front(phi);
                    phi->add_use_def();
                    if (!W.count(Y)) {
                        W.insert(Y);
                        if (Y == *X) {
                            dirty = true;
                        }
                    }
                }
            }
            if (!dirty) {
                W.erase(X);
            }
        }
    }

    // second stage,rename var
    std::list<Ir::BasicBlock*> query;
    auto start = func->get_bbs().begin()->get();
    query.push_back(start);
    unordered_map<BasicBlock*,unordered_map<Type *,unordered_set<shared_ptr<Type>>>> read_before_write; // write在gcm中必须在这些read下面
    while (!query.empty()) {
        auto bb = query.front();
        read_before_write[bb] = read_before_write[bb->idom_by];
        for (auto iter = bb->get_instrs().begin();iter != bb->get_instrs().end();) {
            Instanceof(load,LoadInstr*,iter->get()) {
                // 这是最根本的base,要找当前dom域下最近的新的地址
                auto base = mem2scope[load->get_addr().get()];
                BasicBlock* runner = bb;
                while(runner && !reachingDefs[runner].count(base)) {
                    runner = runner->idom_by;
                }
                load->remove_use_def();
                shared_ptr<Vector> scope = static_pointer_cast<Vector>(reachingDefs[runner][base]);
                auto *mem_read = new MemRead(load->get_dst(),
                                            scope,load->get_addr(),false);
                iter->reset(mem_read);
                mem_read->set_belongto_bb(bb);
                mem_read->add_use_def();
                read_before_write[bb][base].insert(mem_read->get_dst());
            } else Instanceof(loadGlobal,LoadGlobal*,iter->get()) {
                // 这是最根本的base,要找当前dom域下最近的新的地址
                auto base = mem2scope[loadGlobal->get_addr().get()];
                BasicBlock* runner = bb;
                while(runner && !reachingDefs[runner].count(base)) {
                    runner = runner->idom_by;
                }
                loadGlobal->remove_use_def();
                shared_ptr<Reg> scope = static_pointer_cast<Reg>(reachingDefs[runner][base]);
                auto *mem_read = new MemRead(loadGlobal->get_dst(),
                                            scope,loadGlobal->get_addr(),false);
                iter->reset(mem_read);
                mem_read->set_belongto_bb(bb);
                mem_read->add_use_def();
                read_before_write[bb][base].insert(mem_read->get_dst());
            } else Instanceof(loadVector,LoadVector*,iter->get()) {
                iter++; // 不需要重命名,地址转换关系在之前就完成了
            } else Instanceof(loadArray,LoadArray*,iter->get()) {
                iter++; // 不需要重命名,地址转换关系在之前就完成了
            } else Instanceof(store,StoreInstr*,iter->get()) {
                // 这是最根本的base,要找当前dom域下最近的新的地址
                auto base = mem2scope[store->get_addr().get()];
                BasicBlock* runner = bb;
                while(runner && !reachingDefs[runner].count(base)) {
                    runner = runner->idom_by;
                }
                store->remove_use_def();
                shared_ptr<Vector> new_scope = Factory::get_vector(base->get_type());
                // store 修改了内存空间,可以认为产生了新的内存地址,之后的load都是用的行scope
                shared_ptr<Vector> scope = static_pointer_cast<Vector>(reachingDefs[runner][base]);
                auto *mem_write = new MemWrite(store->get_addr(),
                                             store->get_val(),scope,new_scope,false);
                iter->reset(mem_write);
                mem_write->set_belongto_bb(bb);
                reachingDefs[bb][base] = new_scope;
                mem_write->read_before_write = read_before_write[bb][base];
                mem_write->add_use_def();
                read_before_write[bb][base].clear();
            } else Instanceof(storeGlobal,StoreGlobal*,iter->get()) {
                auto base = mem2scope[storeGlobal->get_addr().get()];
                BasicBlock* runner = bb;
                while(runner && !reachingDefs[runner].count(base)) {
                    runner = runner->idom_by;
                }
                storeGlobal->remove_use_def();
                shared_ptr<Reg> new_scope = Factory::get_reg(base->get_type());
                shared_ptr<Reg> scope = static_pointer_cast<Reg>(reachingDefs[runner][base]);
                auto *mem_write = new MemWrite(storeGlobal->get_addr(),
                                              storeGlobal->get_val(),scope,new_scope,false);
                iter->reset(mem_write);
                mem_write->set_belongto_bb(bb);
                reachingDefs[bb][base] = new_scope;
                mem_write->read_before_write = read_before_write[bb][base];
                mem_write->add_use_def();
                read_before_write[bb][base].clear();
            } else Instanceof(alloc,AllocaInstr*,iter->get()) {
                iter++; // 已经迁移到第一步之前完成了reachdef的维护
            } else Instanceof(phi,ArrayPhi*,iter->get()) {
                // 维护一下reach defs 差不多得了
                auto base = phi->get_scope();// base,最根本的地址
                reachingDefs[bb][base.get()] = phi->get_dst();
                auto scope = phi->get_scope();
                phi->remove_use_def();
                phi->read_before_write = read_before_write[bb][scope.get()]; // 寄,他的前驱scope不知道,只能通过base来获取了
                phi->add_use_def();
                iter++;
                read_before_write[bb][scope.get()].clear();
            } else Instanceof(call,CallInstr*,iter->get()) { // 这里是为了维护这个func里面scope的有序,call之前形成,gvn gcm都不可以超过该界限,
                // 最麻烦的,GG
                // 首先是mem read
                auto call_func = call->get_function();
                auto params = call->get_params();
                unordered_map<shared_ptr<Type>,shared_ptr<Type>> read2write;
                for(const auto& read:func_read_global[call_func]) { // 看成call read 了 这些全局变量,直接显式read,后面Memdef的时候好用
                    auto base = read.get();
                    auto runner = bb;
                    while(runner && !reachingDefs[runner].count(base)) {
                        runner = runner->idom_by;
                    }
                    auto scope = reachingDefs[runner][base];
                    MemRead* mem_read;
                    Instanceof(__reg,Reg*,read.get()) {
                        auto dst = Factory::get_reg(read->get_type());
                        mem_read = new MemRead(dst, scope, read, true);
                    } else Instanceof(__vector,Vector*,read.get()) {
                        auto dst = Factory::get_vector(read->get_type());
                        for(auto &dis:__vector->get_dims()) {
                            dst->get_dims().push_back(dis);
                        }
                        mem_read = new MemRead(dst, scope, read, true);
                    } else assert(false);
                    mem_read->set_belongto_bb(bb);
                    mem_read->add_use_def();
                    iter = bb->get_instrs().emplace(iter,mem_read);
                    iter++; // 保证都在call前写,
                    read2write[read] = mem_read->get_dst();// 下次 write写这里
                    read_before_write[bb][base].insert(mem_read->get_dst());
                    call->used_global.insert(mem_read->get_dst());
                }
                for(auto read_subscript:func_read_param[call_func]) { // 这里可以看成call read 了 这些地址,我们这里直接read出来,call需要修改参数
                    auto read = params[read_subscript];
                    auto base = mem2scope[read.get()];
                    auto runner = bb;
                    while(runner && !reachingDefs[runner].count(base)) {
                        runner = runner->idom_by;
                    }
                    shared_ptr<Vector> scope = static_pointer_cast<Vector>(reachingDefs[runner][base]);
                    auto dst = Factory::get_vector(read->get_type());
                    Instanceof(vec,Vector*,read.get()) {
                        for(auto &dis:vec->get_dims()) {
                            dst->get_dims().push_back(dis);
                        }
                    } else assert(false);
                    auto mem_read = new MemRead(dst,scope,read,true);
                    mem_read->set_belongto_bb(bb);
                    mem_read->add_use_def();
                    iter = bb->get_instrs().emplace(iter,mem_read);
                    iter++;
                    read2write[read] = dst;// 下次 write写这里
                    // param还要修改use
                    call->change_use_name(read->get_id(),dst);
                    read_before_write[bb][base].insert(mem_read->get_dst());
                }
                iter++; // 到call后面
                // 然后是mem write
                if(call->is_void_flag()) {
                    auto val_tmp_reg = Factory::get_reg(Int);
                    call->set_dst(val_tmp_reg);
                }
                call->add_use_def();
                for(const auto& write:func_write_global[call_func]) {
                    auto base = write.get();
                    auto runner = bb;
                    while(runner && !reachingDefs[runner].count(base)) {
                        runner = runner->idom_by;
                    }
                    auto scope = reachingDefs[runner][base];
                    MemWrite * mem_write;
                    Instanceof(_,Reg*,base) {
                        auto new_scope = Factory::get_reg(base->get_type());
                        mem_write = new MemWrite(read2write[write], call->get_dst(), scope, new_scope, true);
                        reachingDefs[bb][base] = new_scope;
                    } else Instanceof(__,Vector*,base) {
                        auto new_scope = Factory::get_vector(base->get_type());
                        for(auto dis:__->get_dims()) {
                            new_scope->get_dims().push_back(dis);
                        }

                        mem_write = new MemWrite(read2write[write], call->get_dst(), scope, new_scope, true);
                        reachingDefs[bb][base] = new_scope;
                    } else {
                        info("base is not global var and vector. array ssa failed");
                        assert(false);
                        return ;
                    }
                    mem_write->set_belongto_bb(bb);

                    iter = bb->get_instrs().emplace(iter,mem_write);
                    mem_write->read_before_write = read_before_write[bb][base];
                    mem_write->add_use_def();
                    iter++;
                    read_before_write[bb][base].clear();
                }
                for(auto write_subscript:func_write_param[call_func]) {
                    auto write = params[write_subscript];
                    auto base = mem2scope[write.get()];
                    auto runner = bb;
                    while(runner && !reachingDefs[runner].count(base)) {
                        runner = runner->idom_by;
                    }
                    shared_ptr<Vector> scope = static_pointer_cast<Vector>(reachingDefs[runner][base]);
                    auto dst = Factory::get_vector(write->get_type());
                    auto *mem_write = new MemWrite(read2write[write], call->get_dst(),scope, dst, true);
                    mem_write->set_belongto_bb(bb);

                    iter = bb->get_instrs().emplace(iter,mem_write);
                    iter++;
                    reachingDefs[bb][base] = dst;
                    mem_write->read_before_write = read_before_write[bb][base];
                    mem_write->add_use_def();
                    read_before_write[bb][base].clear();
                }
            } else iter++;
        }
        for (auto &succ : bb->succ) {
            for (auto &inst:succ->get_instrs()) {
                Instanceof(phi,ArrayPhi*,inst.get()) {
                    // 维护一下incoming
                    phi->remove_use_def();
                    BasicBlock * runner = bb;
                    auto base = phi->get_scope();
                    while(runner && !reachingDefs[runner].count(base.get())) {
                        runner = runner->idom_by;
                    }
                    if(!runner)
                        continue;
                    phi->get_bb_2_value()[bb] = reachingDefs[runner][base.get()];
                    // 维护一下use def
                    phi->add_use_def();
                } else break;
            }
        }
        for (auto &item : bb->idom) {
            if (bb != item) {
                query.push_back(item);
            }
        }
        query.pop_front();
    }
}


void array_mem2reg(CompileUnit* compileUnit) {
    // 从main函数开始,获得每个函数 write 了的全局变量和参数
    Function * main_func = nullptr;
    for(auto &func:compileUnit->get_functions()) {
        if(func->get_name() == "main") {
            main_func = func.get();
            break;
        }
    }
    func_read_global.clear();
    func_write_global.clear();
    func_write_param.clear(); // 装param id
    func_read_param.clear(); // 装param id
    visited_func.clear();
    find_mem_write(main_func);

    for(auto &func:compileUnit->get_functions()) {
        Factory::reset(func.get());
        array_mem2reg(func.get(),compileUnit);
        func->set_reg_max_num(Factory::reg_num);
        func->set_bb_max_num(Factory::bb_num);
    }
    CompileUnit::in_array_ssa = true;
    info("in array ssa");
}
}
