//
// Created by shliba on 2023/8/9.
//

#include "opt.h"


namespace opt {
    std::unordered_set<Ir::Instruction*> array_delete_instrs;
    void array_pass(Ir::CompileUnit * cu) {
        std::unordered_map<std::string, bool> dirties;
        for (auto &item: cu->get_globals()) {
            Instanceof(vec, Ir::Vector*, item.get()) {
                dirties.insert({vec->get_name(), false});
            }
        }
        for (const auto &func: cu->get_functions()) {
            for (const auto &bb: func->get_bbs()) {
                for (const auto &instr: bb->get_instrs()) {
                    Instanceof(store, Ir::LoadInstr*, instr.get()) {
                        auto def = func->def_place[store->get_addr()->get_id()];
                        Instanceof(load, Ir::LoadArray*, def) {
                            if (!load->get_addr()->get_name().empty()) {
                                if (load->get_addr()->get_name() == "y") {
                                    int x = 10;
                                }
                                dirties[load->get_addr()->get_name()] = true;
                            }
                        }
                    }
                    Instanceof(load, Ir::LoadVector*, instr.get()) {
                        if (!load->get_addr()->get_name().empty()) {
                            dirties[load->get_addr()->get_name()] = true;
                        }
                    }
                }
            }
        }

        for (const auto &func: cu->get_functions()) {
            for (const auto &bb: func->get_bbs()) {
                for (const auto &instr: bb->get_instrs()) {
                    Instanceof(store, Ir::StoreInstr*, instr.get()) {
                        auto def = func->def_place[store->get_addr()->get_id()];
                        Instanceof(load, Ir::LoadArray*, def) {
                            if (!load->get_addr()->get_name().empty() && !dirties[load->get_addr()->get_name()]) {
                                array_delete_instrs.insert(store);
                                array_delete_instrs.insert(load);
                            }
                        }
                    }
                }

            }
            for (auto &bb : func->get_bbs()) {
                auto instr_it = bb->get_instrs().begin();
                while (instr_it != bb->get_instrs().end()) {
                    if (array_delete_instrs.count(instr_it->get())) {
                        (*instr_it)->remove_use_def();
                        instr_it = bb->get_instrs().erase(instr_it);
                    } else {
                        instr_it++;
                    }
                }
            }
            auto it = cu->get_globals().begin();
            while (it != cu->get_globals().end()) {
                Instanceof(vec, Ir::Vector*, it->get()) {
                    if (!dirties[vec->get_name()]) {
                        it = cu->get_globals().erase(it);
                        continue ;
                    }
                }
                it++;
            }
        }
    }
}