//
// Created by shliba on 2022/12/3.
//
#include "opt.h"
#include "../utils/logger.h"

namespace opt {



std::unordered_set<Ir::Instruction*> dump_delete_instrs;
void replace_all_use(std::shared_ptr<Ir::Reg> &old_reg, std::shared_ptr<Ir::Reg> &new_reg, Ir::Function* func) {
    auto &user = func->use_place[old_reg->get_id()];

    while (!user.empty()) {
        auto instr = user.begin();
        (*instr)->change_use_name(old_reg->get_id(), new_reg);

    }
}
void solve_combine(Ir::BinaryInstr* BinaryInstr, std::pair<Ir::BinaryInstr*, int>& last,
                   Ir::BasicBlock*bb, decltype(bb->get_instrs().begin())& instr_it, int sel) {

    shared_ptr<Ir::Reg> add = sel == 1 ? BinaryInstr->get_src_1() : BinaryInstr->get_src_2();
    shared_ptr<Ir::Reg> src = sel == 1 ? BinaryInstr->get_src_2() : BinaryInstr->get_src_1();
    auto type = BinaryInstr->def()->get_type();
    Ir::RegConst reg_const;
    reg_const.int_num = last.second;
    if (last.first != nullptr) {
        auto num = Ir::Factory::get_const_reg(Ir::Int, reg_const);

        if (add != src) {
            auto new_reg = Ir::Factory::get_reg(type);
            auto new_mult = Ir::Factory::get_binary(new_reg, add,
                                                   num, Ir::MUL);
            auto new_add = Ir::Factory::get_binary(last.first->get_dst(), new_reg,
                                                  src, Ir::ADD);
            last.first->set_dst(Ir::Factory::get_zero_reg(Ir::Int));
            new_mult->set_belongto_bb(bb);
            new_add->set_belongto_bb(bb);

            new_mult->add_use_def();
            new_add->add_use_def();
            instr_it = bb->get_instrs().insert(instr_it, std::move(new_mult));
            instr_it++;
            instr_it = bb->get_instrs().insert(instr_it, std::move(new_add));
            instr_it++;
            dump_delete_instrs.insert({BinaryInstr, last.first});
        } else {
            num->get_num().int_num = num->get_num().int_num + 1;
            //                for (int i = 0; i < num->getNum(); ++i) {
            auto new_mult = Ir::Factory::get_binary(last.first->get_dst(), BinaryInstr->get_src_2(),
                                                   num, Ir::MUL);
            last.first->set_dst(Ir::Factory::get_zero_reg(Ir::Int));
            new_mult->set_belongto_bb(bb);
            new_mult->add_use_def();
            instr_it = bb->get_instrs().insert(instr_it, std::move(new_mult));
            //                }
            instr_it++;
            dump_delete_instrs.insert({BinaryInstr, last.first});
        }
    }
}

std::pair<Ir::BinaryInstr*, int> combine_add(Ir::BinaryType op, std::shared_ptr<Ir::Reg>& add, Ir::BinaryInstr* BinaryInstr,Ir::Function* func) {

    bool flag = true;

    int num = 2;
    std::unordered_set<Ir::Instruction*> temp_list;

    while (flag) {
        //            if (num == 63) {
        //                break;
        //            }
        flag = false;
        auto users = func->use_place[BinaryInstr->def()->get_id()];
        auto user_instr = *users.begin();
        if (users.size() == 1) {
            Instanceof(user_BinaryInstr, Ir::BinaryInstr*, user_instr) {
                if (BinaryInstr->get_binary_type() == op) {
                    if (*user_BinaryInstr->get_src_1() == *add) {
                        temp_list.insert(BinaryInstr);
                        flag = true;
                        BinaryInstr = user_BinaryInstr;
                        num++;
                    } else if (*user_BinaryInstr->get_src_2() == *add) {
                        temp_list.insert(BinaryInstr);
                        flag = true;
                        BinaryInstr = user_BinaryInstr;
                        temp_list.insert(BinaryInstr);
                        num++;
                    }
                }
            }
        }
    }
    if (num > 5) {
        std::for_each(temp_list.begin(), temp_list.end(), [](Ir::Instruction* instr){dump_delete_instrs.insert(instr);});
        return {BinaryInstr, num};
    } else {
        return {nullptr, 0};
    }
}

void dumplicated_code(Ir::CompileUnit* compUnit) {
    for (auto &func: compUnit->get_functions()) {
        dump_delete_instrs.clear();
        Ir::Factory::reset(func.get());
        for (auto &bb : func->get_bbs()) {
            auto instr_it = bb->get_instrs().begin();
            while (instr_it != bb->get_instrs().end()) {

                if (dump_delete_instrs.count(instr_it->get())) {
                    instr_it++;
                    continue;
                }
                Instanceof(BinaryInstr, Ir::BinaryInstr*, instr_it->get()) {
                    if (BinaryInstr->get_binary_type() == Ir::MUL) {
                        auto users = func->use_place[BinaryInstr->def()->get_id()];
                        auto user_instr = *users.begin();
                        Instanceof(user_BinaryInstr, Ir::BinaryInstr*, user_instr) {
                            if (user_BinaryInstr->get_binary_type() == Ir::SDIV) {
                                if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_1()) {
                                    replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_2(), func.get());
                                    if (user_BinaryInstr->get_dst()->get_id() == 3014) {
                                      int x = 10;
                                    }
                                    if (users.size() == 1) {
                                        dump_delete_instrs.insert(BinaryInstr);
                                    }
                                    dump_delete_instrs.insert(user_BinaryInstr);
                                } else if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_2()) {
                                    replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                                    if (user_BinaryInstr->get_dst()->get_id() == 3014) {
                                        int x = 10;
                                    }
                                    if (users.size() == 1) {
                                        dump_delete_instrs.insert(BinaryInstr);
                                    }
                                    dump_delete_instrs.insert(user_BinaryInstr);
                                }
                            }
                            //                                }
                        }
                    }
                    if (BinaryInstr->get_binary_type() == Ir::SDIV) {
                        auto &users = func->use_place[BinaryInstr->def().get()->get_id()];
                        if (users.size() == 1) {
                            auto user_instr = *users.begin();
                            Instanceof(user_BinaryInstr, Ir::BinaryInstr*, user_instr) {
                                if (user_BinaryInstr->get_binary_type() == Ir::MUL) {
                                    if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_2()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_2(), func.get());
                                        if (users.size() == 1) {
                                            dump_delete_instrs.insert(BinaryInstr);
                                        }
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    } else if (user_BinaryInstr->get_src_1() == BinaryInstr->get_src_2()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                                        if (users.size() == 1) {
                                            dump_delete_instrs.insert(BinaryInstr);
                                        }
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    }
                                } else if (user_BinaryInstr->get_binary_type() == Ir::SDIV) {
                                    if (*user_BinaryInstr->get_src_1() == *BinaryInstr->get_dst()) {
                                        user_BinaryInstr->change_use_name(BinaryInstr->get_dst(),
                                                                          BinaryInstr->get_src_1());
                                        BinaryInstr->change_use_name(BinaryInstr->get_src_1(), user_BinaryInstr->get_src_2());
                                        BinaryInstr->setBinaryType(Ir::MUL);
                                        user_BinaryInstr->change_use_name(user_BinaryInstr->get_src_2(), BinaryInstr->get_dst());
                                    }
                                }
                            }
                        }
                    }
                    if (BinaryInstr->get_binary_type() == Ir::ADD) {
                        if (is_const_zero(BinaryInstr->get_src_1())) {
                            replace_all_use(BinaryInstr->get_dst(), BinaryInstr->get_src_2(), func.get());
                            dump_delete_instrs.insert(BinaryInstr);
                        } else if (is_const_zero(BinaryInstr->get_src_2())){
                            replace_all_use(BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                            dump_delete_instrs.insert(BinaryInstr);
                        }
                        auto users = func->use_place[BinaryInstr->def()->get_id()];
                        if (users.size() == 1) {
                            auto user_instr = *users.begin();
                            Instanceof(user_BinaryInstr, Ir::BinaryInstr*, user_instr) {
                                if (user_BinaryInstr->get_binary_type() == Ir::SUB) {
                                    if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_1()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_2(), func.get());
                                        dump_delete_instrs.insert(BinaryInstr);
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    } else if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_2()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                                        dump_delete_instrs.insert(BinaryInstr);
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    }
                                }
                                if (user_BinaryInstr->get_binary_type() == Ir::ADD) {
                                    if (*user_BinaryInstr->get_src_1() == *BinaryInstr->get_src_2()) {
                                        auto last = combine_add(Ir::ADD, BinaryInstr->get_src_2(), user_BinaryInstr, func.get());
                                        if (last.first != nullptr) {
                                            solve_combine(BinaryInstr, last, bb.get(), instr_it, 2);
                                        }
                                    } else if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_2()) {
                                        auto last = combine_add(Ir::ADD, BinaryInstr->get_src_2(), user_BinaryInstr, func.get());
                                        if (last.first != nullptr) {
                                            solve_combine(BinaryInstr, last, bb.get(), instr_it, 2);
                                        }
                                    } else if (*user_BinaryInstr->get_src_1() == *BinaryInstr->get_src_1()) {
                                        auto last = combine_add(Ir::ADD, BinaryInstr->get_src_1(), user_BinaryInstr, func.get());
                                        if (last.first != nullptr) {
                                            solve_combine(BinaryInstr, last, bb.get(), instr_it, 1);
                                        }
                                    } else if (*user_BinaryInstr->get_src_1() == *BinaryInstr->get_src_2()) {
                                        auto last = combine_add(Ir::ADD, BinaryInstr->get_src_1(), user_BinaryInstr, func.get());
                                        if (last.first != nullptr) {
                                            solve_combine(BinaryInstr, last, bb.get(), instr_it, 1);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (BinaryInstr->get_binary_type() == Ir::SUB) {
                        auto users = func->use_place[BinaryInstr->def()->get_id()];
                        if (users.size() == 1) {
                            auto user_instr = *users.begin();
                            Instanceof(user_BinaryInstr, Ir::BinaryInstr*, user_instr) {
                                if (user_BinaryInstr->get_binary_type() == Ir::ADD) {
                                    if (*user_BinaryInstr->get_src_1() == *BinaryInstr->get_src_2()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                                        dump_delete_instrs.insert(BinaryInstr);
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    } else if (*user_BinaryInstr->get_src_2() == *BinaryInstr->get_src_2()) {
                                        replace_all_use(user_BinaryInstr->get_dst(), BinaryInstr->get_src_1(), func.get());
                                        dump_delete_instrs.insert(BinaryInstr);
                                        dump_delete_instrs.insert(user_BinaryInstr);
                                    }
                                }
                            }
                        }
                    }
                }
                instr_it++;
            }
        }
        for (auto &bb : func->get_bbs()) {
            auto instr_it = bb->get_instrs().begin();
            while (instr_it != bb->get_instrs().end()) {
                if (dump_delete_instrs.count(instr_it->get())) {
                    (*instr_it)->remove_use_def();

                    instr_it = bb->get_instrs().erase(instr_it);
                } else {
                    instr_it++;
                }
            }
        }
        func->set_reg_max_num(Ir::Factory::reg_num);
        func->set_bb_max_num(Ir::Factory::bb_num);
    }
}
}