//
// Created by shliba on 2023/8/6.
//
#include "opt.h"

namespace opt {
    void fib_opt(Ir::CompileUnit* compUnit) {
        for (auto &func : compUnit->get_functions()) {
            if (func->is_recur() && !func->is_void()) {
                auto first = Ir::RegConst();
                auto second = Ir::RegConst();
                auto back = func->get_bbs().back().get();
                auto tail_num = 0;
                auto def1 = Ir::Factory::get_zero_reg(Ir::Int);
                auto def2 = Ir::Factory::get_zero_reg(Ir::Int);
                auto last_instr = back->get_instrs().back().get();
                Instanceof (ret, Ir::Ret*, last_instr) {
                    if (func->def_place.count(ret->get_src()->get_id())) {
                        auto t = func->def_place[ret->get_src()->get_id()];
                        Instanceof(binary,  Ir::BinaryInstr*, t) {
                            if (binary->get_binary_type() == Ir::ADD) {
                                for (auto &use : binary->get_uses()) {
                                    if (!func->def_place.count(use->get_id())) {
                                        break;
                                    }
                                    auto instr = func->def_place[use->get_id()];
                                    Instanceof(call, Ir::CallInstr*, instr) {
                                        if (call->get_function()->get_name() == func->get_name() && call->get_params().size() == 1) {
                                            if (tail_num == 2) {
                                                return;
                                            }

                                            auto param = call->get_params().back();
                                            tail_num++;
                                            if (func->def_place.count(param->get_id())) {
                                                if (tail_num == 1) {
                                                    def1 = std::dynamic_pointer_cast<Ir::Reg>(use);
                                                } else {
                                                    def2 = std::dynamic_pointer_cast<Ir::Reg>(use);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                auto flag = false;
                if (tail_num == 2 && !def1->is_constant() && !def2->is_constant()) {
                    for (auto &bb : func->get_bbs()) {
                        Instanceof(ret, Ir::Ret*, bb->get_instrs().back().get()) {
                            if (ret->get_src()->is_constant()) {
                                if (bb->prev.size() != 1) {
                                    break;
                                }
                                auto prev = *bb->prev.begin();
                                Instanceof(br, Ir::BranchInstr*, prev->get_instrs().back().get()) {
                                    auto reg_id = br->get_reg()->get_id();
                                    if (br->get_bb_2() != nullptr && func->def_place.count(reg_id)) {
                                        Instanceof(icmp, Ir::BinaryInstr*,func->def_place[reg_id]) {
                                            if (icmp->get_binary_type() == Ir::EQ) {
                                                if (icmp->get_src_2()->is_constant() && icmp->get_src_2()->get_num().int_num == 1) {
                                                    first = ret->get_src()->get_num();
                                                    flag = true;
                                                } else if (icmp->get_src_2()->is_constant() && icmp->get_src_2()->get_num().int_num == 1) {
                                                    second = ret->get_src()->get_num();
                                                    flag = true;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (!flag) {
                        second.int_num = 1;
                        flag = true;
                    }
                    if (flag) {

                        Ir::Factory::reset(func.get());

                        list<std::unique_ptr<Ir::BasicBlock>> new_bbs;
                        auto entry = Ir::Factory::get_noadd_new_bb(nullptr, func.get());
                        auto header = Ir::Factory::get_noadd_new_bb(nullptr, func.get());
                        auto ret_bb = Ir::Factory::get_noadd_new_bb(nullptr, func.get());

                        //entry
                        auto type1 = Ir::Int;



                        auto ret1 = Ir::Factory::get_alloca(type1);
                        auto ret2 = Ir::Factory::get_alloca(type1);
                        auto loop_var = Ir::Factory::get_alloca(Ir::Int);



                        auto start_val = Ir::Factory::get_reg(Ir::Int);
                        auto first_val = Ir::Factory::get_reg(Ir::Int);
                        auto second_val = Ir::Factory::get_reg(Ir::Int);

                        first_val->set_num(first);
                        second_val->set_num(second);

                        auto ret1_reg = dynamic_cast<Ir::AllocaInstr*>(ret1.get())->get_addr();
                        auto ret2_reg = dynamic_cast<Ir::AllocaInstr*>(ret2.get())->get_addr();
                        auto var_reg = dynamic_cast<Ir::AllocaInstr*>(loop_var.get())->get_addr();
                        entry->push_back(ret1);
                        entry->push_back(ret2);
                        entry->push_back(loop_var);
                        Ir::Factory::build_store(first_val, ret1_reg, *entry);
                        Ir::Factory::build_store(second_val, ret2_reg, *entry);
                        Ir::Factory::build_store(start_val, var_reg, *entry);
                        Ir::Factory::build_branch(header.get(), *entry);


                        //header
                        auto src1 = Ir::Factory::get_reg(type1);
                        auto src2 = Ir::Factory::get_reg(type1);
                        Ir::Factory::build_load(src1, ret1_reg, *header);
                        Ir::Factory::build_load(src2, ret2_reg, *header);
                        auto new_dst = Ir::Factory::get_reg(type1);
                        Ir::Factory::build_binary(new_dst, src1, src2, Ir::ADD,*header);
                        Ir::Factory::build_store(src2, ret1_reg, *header);
                        Ir::Factory::build_store(new_dst, ret2_reg, *header);
                        auto old_val = Ir::Factory::get_reg(type1);
                        Ir::Factory::build_load(old_val, var_reg, *header);
                        auto new_val = Ir::Factory::get_reg(type1);
                        auto one = Ir::Factory::get_zero_reg(type1);
                        one->get_num().int_num = 1;
                        Ir::Factory::build_binary(new_val, old_val, one, Ir::ADD, *header);
                        Ir::Factory::build_store(new_val, var_reg, *header);
                        auto judge_val = Ir::Factory::get_reg(Ir::Int);
                        Ir::Factory::build_load(judge_val, var_reg, *header);
                        auto cond = Ir::Factory::get_reg(Ir::Bool);
                        Ir::Factory::build_binary(cond, judge_val, std::dynamic_pointer_cast<Ir::Reg>(func->get_params().back()), Ir::SLE, *header);
                        Ir::Factory::build_branch(cond, header.get(), ret_bb.get(), *header);

                        //ret_bb
                        auto ret_val = Ir::Factory::get_reg(Ir::Int);
                        Ir::Factory::build_load(ret_val, ret2_reg, *ret_bb);
                        Ir::Factory::build_ret(ret_val, *ret_bb);

                        func->get_loops().clear();
                        auto new_loop = Ir::Factory::get_loop(header.get(), ret_bb.get(), 1, func.get(), nullptr);
                        header->set_belong_to_loop(new_loop);
                        func->get_bbs().clear();

                        func->get_bbs().push_back(std::move(entry));

                        func->get_bbs().push_back(std::move(header));

                        func->get_bbs().push_back(std::move(ret_bb));
                        func->set_recur(false);
                        func->set_bb_max_num(Ir::Factory::bb_num);
                        func->set_reg_max_num(Ir::Factory::reg_num);
                    }
                }
            }
        }
    }


}

