//
// Created by 11069 on 7/8/2023.
//
// 对于多维数组,取值的gep指令很长,这其中有些地址变换被重复计算 比如 a[1][2] 和 a[1][3],a[1]作为基址应该可以重复使用,本pass用于将多维的gep拆分,然后gvn优化访存

#include "opt.h"
using namespace Ir;
namespace opt {

    void gep_split(Function* func) {
        for(auto &bb:func->get_bbs()) {
            for(auto iter = bb->get_instrs().begin();iter != bb->get_instrs().end();) {
                auto &inst = *iter;
                Instanceof(loadArray,LoadArray*,inst.get()) {

                    auto vec = loadArray->get_addr();
                    int dimes = loadArray->get_indexs().size();
                    if(dimes <= 1) {
                        iter++;
                        continue ;
                    }
                    // 插入loadvector
                        auto dst = Factory::get_vector(vec->get_type());
                        vector<shared_ptr<Reg>> new_index;
                        dst->get_dims().push_back(0);
                        for (int i = 0; i + 1 < loadArray->get_indexs().size(); ++i) {
                            new_index.push_back(loadArray->get_indexs()[i]);
                        }
                        auto new_loadVector = new LoadVector(dst, vec, new_index);
                        new_loadVector->set_belongto_bb(loadArray->get_belongto_bb());
                        iter = bb->get_instrs().emplace(iter,new_loadVector);
                        new_loadVector->add_use_def();
                        iter++;
                        vec = dst;

                    // 插入新的 loadArray
                    auto mem = Factory::get_mem(vec->get_type());
                    new_index.clear();
                    new_index.push_back(loadArray->get_indexs()[dimes-1]);
                    auto new_array = new LoadArray(mem, vec, new_index);
                    new_array->set_belongto_bb(loadArray->get_belongto_bb());
                    new_array->add_use_def();
                    iter = bb->get_instrs().emplace(iter,new_array);
                    iter++;
                    copy_propagation(func->use_place,loadArray->get_dst()->get_id(),new_array->get_dst());
                    loadArray->remove_use_def();
                    iter = bb->get_instrs().erase(iter);
                }  else  { iter ++; }
            }
        }
    }

    void gep_split(CompileUnit* compileUnit) {
        for(auto &func:compileUnit->get_functions()) {
            if(func->is_lib())
                continue ;
            Factory::reset(func.get());
            gep_split(func.get());
            func->set_reg_max_num(Factory::reg_num);
            func->set_bb_max_num(Factory::bb_num);
        }
    }
}