//
// Created by 11069 on 6/8/2023.
//

# include "opt.h"
using namespace Ir;

namespace opt{

/*
 while(j < end_j) {
    if(j > i) {
      j ++; // useless
      continue;
    }
 }
 */


static bool is_valid_cmp(BinaryType op) {
  return op == SLE || op == SLT || op == SGE || op == SGT;
}

void try_to_reduce(Function* func,Loop* loop) {
  auto header = loop->get_header();
  BasicBlock * exit = nullptr;
  BasicBlock * exit_prev = nullptr;
  for(auto &bb:loop->get_all_bbs()) {
    for(auto & succ:bb->succ) {
      if(!loop->get_all_bbs().count(succ)) {
        if(exit && exit != succ)
          return ;
        exit = succ;
        if(bb->succ.count(header))
          exit_prev = bb; // 单纯用来修改phi的,无所谓是否唯一
      }
    }
  }
  if(!exit)
    return ;
  for(auto &bb:loop->get_all_bbs()) {
    if(bb->get_belong_to_loop() != loop)
      continue ;
    Instanceof(br,BranchInstr*,bb->get_instrs().back().get()) {
       if(!br->get_bb_2())
         continue ;
       Instanceof(cnd,BinaryInstr*,func->def_place[br->get_reg()->get_id()]) {
         if(!is_valid_cmp(cnd->get_binary_type())) {
           continue ;
         }
         auto reg_i = cnd->get_src_2(),reg_j = cnd->get_src_1();
         if(is_loop_const(reg_i.get(),func,loop) == is_loop_const(reg_j.get(),func,loop))
           continue ;
         if(is_loop_const(reg_j.get(),func,loop))
           swap_cond(cnd);
         reg_i = cnd->get_src_2();
         reg_j = cnd->get_src_1();
         BinaryType op = cnd->get_binary_type();
         BasicBlock* true_bb = br->get_bb_1(),*false_bb = br->get_bb_2();
         if(true_bb->get_instrs().size() != 2) continue; // upd br
         Instanceof(inner_upd,BinaryInstr*,true_bb->get_instrs().front().get()) {
            if((inner_upd->get_src_1() == reg_j) == (inner_upd->get_src_2() == reg_j))
              continue ;
            if(inner_upd->get_src_2() == reg_j) {
              swap_upd(inner_upd);
            }
            if(op == SGT || op == SGE)
              if(inner_upd->get_src_2()->get_type() != Int || inner_upd->get_src_2()->get_num().int_num <= 0)
                continue ;
            // reg_j + 正数
            if(op == SLT || op == SLE)
              if(inner_upd->get_src_2()->get_type() != Int || inner_upd->get_src_2()->get_num().int_num >= 0)
                continue ;
            Instanceof(inner_br,BranchInstr*,true_bb->get_instrs().back().get()) {
              if(inner_br->get_bb_2())
                continue ;
              if(!header->prev.count(inner_br->get_bb_1()) )
                continue ;
              // 判定为continue
              inner_br->set_bb1(exit);
              true_bb->succ.erase(header);
              header->prev.erase(true_bb);
              true_bb->succ.insert(exit);
              exit->prev.insert(true_bb);
              // modify phi instr
              for(auto &header_inst:header->get_instrs()) {
                Instanceof(header_phi,PhiInstr*,header_inst.get()) {
                  for(auto &exit_inst:exit->get_instrs()) {
                    Instanceof(exit_phi,PhiInstr*,exit_inst.get()) {
                      if(exit_phi->get_bb_2_value().count(header)) {
                        if (exit_phi->get_bb_2_value().at(header) != header_phi->get_bb_2_value().at(header)) break;
                      } else break;
                      if(exit_phi->get_bb_2_value().count(exit_prev)) {
                        if (exit_phi->get_bb_2_value().at(exit_prev) != header_phi->get_bb_2_value().at(exit_prev)) break;
                      } else break;

                      exit_phi->get_bb_2_value()[true_bb] = header_phi->get_bb_2_value().at(true_bb);
                    } else break;
                  }
                  header_phi->get_bb_2_value().erase(true_bb);
                } else break;
              }
            } else continue ;
         } else continue ;
       } else continue ;
    }
  }

}


void meaningless_step_reduction(Function* func) {
  func->cfg->build();
  func->cfg->dom_build();
  func->cfg->loop_analysis();
  for(auto &loop:func->get_loops()) {
    try_to_reduce(func,loop.get());
  }
}

void meaningless_step_reduction(CompileUnit* compileUnit) {
    for(auto &func:compileUnit->get_functions()) {
      if(func->is_lib())
       continue ;
      meaningless_step_reduction(func.get());
    }
}

}