//
// Created by 11069 on 3/7/2023.
//
#include "opt.h"

namespace  opt {
    std::vector<Pass> passes = {
    // global var pass 之后必须跟上mem2reg
    // mark pure func 必须在所有的inst 2 func opt之前完成后
    // func inline 之后 需要global var pass实现对全局变量的进一步优化
    // loop unroll dual 之后不能有loop unroll complete,因为没有意义,unroll dual会给你unroll掉
    // 在loop unroll complete之前尽量完成inline和一些减少代码量的优化,提高unroll成功率

    // 第一阶段,在func inline 之前,减小代码体积,加速inline
    array_pass,
    rebuild_use_def,
    mark_pure_func,
    ret_opt,
    inst_2_func_opt,
//    bitwise_opt,
    inst_2_func_opt,
    dumplicated_code,
    inst_2_func_opt,
    gvn_gcm,
    inst_2_func_opt,
    array_mem2reg,
      gvn_gcm,
      inst_2_func_opt,
      mem_const_propagation,
    arrayssa_destruction,
    inst_2_func_opt,
    meaningless_step_reduction,
    func_inline,
    rebuild_use_def,
    inst_2_func_opt,
    dumplicated_code,
    global_var_pass,
    mem2reg,
    // 第二阶段,inline之后,进行loop unroll complete,对于func call,unroll设置的代价很高,现在正是unroll的好时候
    mark_pure_func,
    ret_opt,
    inst_2_func_opt,
    gvn_gcm,
    binary_opt,
    inst_2_func_opt,

    array_mem2reg,
        gvn_gcm,
        inst_2_func_opt,
        mem_const_propagation,
    arrayssa_destruction,

    inst_2_func_opt,
//    memset_insert,
    inst_2_func_opt,
    gvn_gcm,
    inst_2_func_opt,
    loop_unroll_complete, // unroll 整数倍
    rebuild_use_def,
    inst_2_func_opt,
    gvn_gcm,
    binary_opt,
    inst_2_func_opt,

    array_mem2reg,
        gvn_gcm,
        inst_2_func_opt,
        mem_const_propagation,
        gvn_gcm,
        inst_2_func_opt,
        loop_invariant_store_motion,
        gvn_gcm,
    arrayssa_destruction,
    inst_2_func_opt,
    gvn_gcm,
    inst_2_func_opt,
    loop_unroll_complete, // unroll 整数倍
    inst_2_func_opt,
    dumplicated_code,
    inst_2_func_opt,
    dumplicated_code,
    inst_2_func_opt,
    gvn_gcm,
    binary_opt,
    inst_2_func_opt,

//    loop_unroll_dual, // unroll 2*n+1

    inst_2_func_opt,
    gep_split, // 后面必须有俩gvn,因为第一个gvn只有gcm生效,需要后面的gvn去重
    inst_2_func_opt,
    gvn_gcm,
    binary_opt,
    inst_2_func_opt,
    gvn_gcm,
    inst_2_func_opt,
    rpo,
    };

    void inst_2_func_opt(Ir::CompileUnit *compileUnit) {
        inst_clean_up(compileUnit);
        useless_cf_remove(compileUnit);
        useless_bb_elimination(compileUnit);
        useless_func_clean(compileUnit);
        info("end inst 2 func opt");
    }

    void run_opt(Ir::CompileUnit *compileUnit) {
        for (auto &func : compileUnit->get_functions()) {
            auto cfg = new CFG(func.get());
            cfg->build();
            func->cfg = cfg;
        }


        for(auto &pass:passes) {
            pass(compileUnit);
        }
    }

    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::Reg> dst) {
        while(use_place[src_id].size()) {
            auto iter = use_place[src_id].begin();
            auto inst = *iter;
            inst->change_use_name(src_id,dst);
        }
    }

    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::MemObject> dst) {
        while(use_place[src_id].size()) {
            auto iter = use_place[src_id].begin();
            auto inst = *iter;
            inst->change_use_name(src_id,dst);
        }
    }

    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::Vector> dst) {
        while(use_place[src_id].size()) {
            auto iter = use_place[src_id].begin();
            auto inst = *iter;
            inst->change_use_name(src_id,dst);
        }
    }
}