//
// Created by 11069 on 3/7/2023.
//

#ifndef COMPILER_OPT_H
#define COMPILER_OPT_H

#include "CFG.h"
#include "../utils/logger.h"
#include <algorithm>

namespace opt {
using Ir::CompileUnit;
    const string memset_func_name = "_atri_memset";
    using Pass = void(*)(Ir::CompileUnit *); // 所有opt的文件都要暴露这个接口用于opt.cpp调用
    extern std::vector<Pass> passes;

    void mark_pure_func(Ir::CompileUnit *compileUnit);

    void run_opt(Ir::CompileUnit *compileUnit);



    void convert_pass(Ir::CompileUnit *compileUnit);
    void run_opt(Ir::CompileUnit *compileUnit);

    void mem2reg(Ir::CompileUnit *compileUnit);


    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::Reg> dst);

    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::MemObject> dst);

    void copy_propagation(std::unordered_map<int,std::unordered_set<Ir::Instruction*>> &use_place, int src_id, std::shared_ptr<Ir::Vector> dst);


    void dumplicated_code(Ir::CompileUnit* compUnit);

    void inst_clean_up(CompileUnit* compileUnit);
    void useless_bb_elimination(Ir::CompileUnit * compileUnit);// auto use in dom build
    void mark_pure_func(CompileUnit *compileUnit);
    void useless_func_clean(CompileUnit* compileUnit);
    void useless_cf_remove(CompileUnit* compileUnit);
    void global_var_pass(CompileUnit *compileUnit);
    void gvn_gcm(CompileUnit* compileUnit);
    void loop_unroll_complete(CompileUnit*);
    void loop_unroll_dual(CompileUnit*);
    void inst_2_func_opt(CompileUnit*);
    void global_var_pass(CompileUnit*);
    void rpo(CompileUnit* compileUnit);
    void replace_all_use(std::unordered_set<Ir::Instruction*>& users,
                         int src_id, std::shared_ptr<Ir::Reg>& new_reg);
    void replace_all_use(std::shared_ptr<Ir::Reg> &old_reg, std::shared_ptr<Ir::Reg> &new_reg, Ir::Function* func);
    void array_mem2reg(CompileUnit*);
    void mem_const_propagation(CompileUnit*);
    void arrayssa_destruction(CompileUnit*);
    void binary_opt(CompileUnit*);
    void func_inline(CompileUnit*);
    void dumplicated_code(CompileUnit *);
    void rebuild_use_def(CompileUnit*);
    void ret_opt(CompileUnit *);
    void meaningless_step_reduction(CompileUnit*);
    bool is_const_zero(const shared_ptr<Ir::Reg>& src) ;
    void gep_split(CompileUnit* compileUnit);
    void fib_opt(CompileUnit *);
    void tail_recur(Ir::CompileUnit * cu);
    void swap_upd(Ir::BinaryInstr * upd);
    bool swap_cond(Ir::BinaryInstr * cond);
    bool is_loop_const(Ir::Reg * reg,Ir::Function* func, Ir::Loop * loop);
    void loop_invariant_store_motion(CompileUnit*);
    void bitwise_opt(Ir::CompileUnit * cu);
    void memset_insert(Ir::CompileUnit * cu);
    void array_pass(Ir::CompileUnit * cu);
}

#endif // COMPILER_OPT_H
