//
// Created by 11069 on 25/7/2023.
//

#include "opt.h"
using namespace Ir;
namespace opt{

    void rpo(Function* func) {
        func->cfg->build();
        func->cfg->dom_build();
        BasicBlock * root = func->get_first_bb();
        unordered_set<BasicBlock*> visited_bb;
        vector<BasicBlock*> rpo;//reverse post order
        vector<BasicBlock*> stack;
        stack.push_back(root);
        visited_bb.insert(root);
        while(!stack.empty()) {
            auto bb = stack.back();
            stack.pop_back();
            rpo.push_back(bb);
            for(auto& succ:bb->succ) {
                if(!visited_bb.count(succ)) {
                    stack.push_back(succ);
                    visited_bb.insert(succ);
                }
            }
        }
        int i = 0;
        for(auto &bb:func->get_bbs()) {
            bb.release();
            bb.reset(rpo[i]);
            i++;
        }

    }

    void rpo(CompileUnit* compileUnit) {
        for(auto &func:compileUnit->get_functions()) {
            if(func->is_lib())
                continue ;
            rpo(func.get());
        }
    }
}