//
// Created by shliba on 2023/8/6.
//
#include "opt.h"

namespace opt {

    bool addr_cmp(std::shared_ptr<Ir::Type> cpram, std::shared_ptr<Ir::Type> fpram, Ir::Function* func) {
        if (cpram->get_id() == fpram->get_id()) {
            return true;
        } else {
            auto def = func->def_place[cpram->get_id()];
            Instanceof(load_vector, Ir::LoadVector*, def) {
                if(load_vector->get_addr()->get_id() == fpram->get_id()
                    && load_vector->get_indexs().size() == 0) {
                    return true;
                }
            }
        }
        return false;
    }

    void tail_recur(Ir::CompileUnit * cu) {
        for (const auto &func: cu->get_functions()) {
            if (func->is_recur()) {
                auto ret_bb = func->get_bbs().back().get();
                std::vector<shared_ptr<Ir::MemObject>> params;
                for (auto &bb: func->get_bbs()) {
                    auto it = bb->get_instrs().begin();
                    while (it != bb->get_instrs().end()){
                        auto instr = it->get();
                        auto ret_reg = func->ret_mem;
                        Instanceof(call, Ir::CallInstr*, instr) {
                            if (call->get_function()->get_name() == func->get_name()) {
                                auto this_bb = call->get_belongto_bb();
                                if (this_bb->succ.count(ret_bb)) {
                                    auto next_it = it;
                                    auto flag = false;
                                    next_it++;
                                    while (next_it != bb->get_instrs().end()) {
                                        Instanceof(store, Ir::StoreInstr*, next_it->get()) {
                                            auto mem = store->get_addr();
                                            if (mem->get_id() != ret_reg->get_id()) {
                                                flag = true;
                                                break ;
                                            }
                                        } else Instanceof(br, Ir::BranchInstr*, next_it->get()) {
                                            next_it++;
                                            continue;
                                        } else {
                                            flag = true;
                                            break ;
                                        }
                                        next_it++;
                                    }
                                    auto param_it = func->get_params().begin();
                                    for (int i = 0; i < call->get_params().size(); ++i, param_it++) {
                                        auto cparam = call->get_params()[i];
                                        auto fparam = *param_it;
                                        Instanceof(vec, Ir::Vector*, cparam.get()) {
                                            if (!addr_cmp(cparam, fparam, func.get())) {
                                                flag = true;
                                                break ;
                                            }
                                        }
                                    }
                                    if (!flag) {
                                        func->set_recur(false);
                                        auto first_it = func->get_bbs().begin();;
                                        first_it++;
                                        auto next_bb = (*first_it).get();
                                        auto br = dynamic_cast<Ir::BranchInstr*>(this_bb->get_instrs().back().get());
                                        if (br == nullptr) {
                                            break ;
                                        }

                                        auto store_id = 0;
                                        if (br->get_bb_1() == ret_bb) {
                                            this_bb->succ.erase(br->get_bb_1());
                                            br->set_bb1(next_bb);
                                        }  else {
                                            this_bb->succ.erase(br->get_bb_2());
                                            br->set_bb2(next_bb);
                                        }
                                        this_bb->succ.insert(next_bb);
                                        next_bb->prev.insert(this_bb);
                                        param_it = func->get_params().begin();
                                        for (int i = 0; i < call->get_params().size(); ++i, param_it++) {
                                            auto cparam = call->get_params()[i];
                                            Instanceof(reg, Ir::Reg*, cparam.get()) {
                                                auto store = std::unique_ptr<Ir::Instruction>(new Ir::StoreInstr(
                                                        std::dynamic_pointer_cast<Ir::Reg>(cparam), params[store_id++]));
                                                store->set_belongto_bb(bb.get());
                                                store->add_use_def();

                                                bb->get_instrs().insert(it, std::move(store));
                                            }
                                        }
                                        call->remove_use_def();
                                        it = bb->get_instrs().erase(it);
                                        while (it != bb->get_instrs().end()) {
                                            Instanceof(store, Ir::StoreInstr *, it->get()) {
                                                auto mem = store->get_addr();
                                                if (mem->get_id() == ret_reg->get_id()) {
                                                    it = bb->get_instrs().erase(it);
                                                    continue ;
                                                }
                                            }
                                            it++;
                                        }

                                    }
                                }
                            }

                        } else Instanceof(store, Ir::StoreInstr*, instr) {
                            if (std::find(func->get_params().begin(), func->get_params().end(), store->get_val()) != func->get_params().end()) {
                                params.push_back(store->get_addr());
                            }
                        }
                        if (it == bb->get_instrs().end()) {
                            break ;
                        }
                        it++;
                    }
                }
            }
        }
    }
}

