//
// Created by 11069 on 3/7/2023.
//
#include "opt.h"
namespace opt {
void useless_bb_elimination(Ir::Function *func) { // dfs find all accessible bb
    // mark accessible bb
    std::unordered_set<Ir::BasicBlock *> visited_bb;
    std::vector<Ir::BasicBlock *> s;
    s.push_back(func->get_bbs().begin()->get());
    visited_bb.insert(func->get_bbs().begin()->get());
    while (s.size()) {
        auto bb = s.back();
        s.pop_back();
        for (auto succ : bb->succ) {
            if (visited_bb.count(succ)) {
                continue;
            }
            s.push_back(succ);
            visited_bb.insert(succ);
        }
    }

    for (auto iter = func->get_bbs().begin(); iter != func->get_bbs().end();) {
        auto bb = iter->get();
        if (visited_bb.count(bb)) {
            iter++;
            continue;
        } // erase this bb
        for (auto &succ : bb->succ) {
            succ->prev.erase(bb);
            // remember modify the phi instr
            for (auto &inst : succ->get_instrs()) {
                Instanceof(phi, Ir::PhiInstr *, inst.get()) {
                    if (phi->get_bb_2_value().count(bb)) {
                        phi->remove_use_def();
                        phi->get_bb_2_value().erase(bb);
                        phi->add_use_def();
                    }
                } else Instanceof(array,Ir::ArrayPhi *,inst.get()) {
                    if (array->get_bb_2_value().count(bb)) {
                        array->remove_use_def();
                        array->get_bb_2_value().erase(bb);
                        array->add_use_def();
                    }
                }
                else {
                    break;
                }
            }
        }
        for (auto &prev : bb->prev) {
            prev->succ.erase(bb);
        }
        for (auto &inst : bb->get_instrs()) {
            inst->remove_use_def();
        }
        iter = func->get_bbs().erase(iter);
        // maintain the def place and use place
    }
}

void useless_bb_elimination(Ir::CompileUnit *compileUnit) {
    for (auto &func : compileUnit->get_functions()) {
        if(func->is_lib())
            continue ;
        Ir::Factory::reset(func.get());
        useless_bb_elimination(func.get());
        func->set_bb_max_num(Ir::Factory::bb_num);
        func->set_reg_max_num(Ir::Factory::reg_num);
    }
}
} // namespace opt
