//
// Created by 11069 on 13/7/2023.
//
// engineering a compiler 10.2

// fold

// remove

// combine

// hoist

#include "opt.h"
using namespace Ir;

namespace opt {

bool one_pass(BasicBlock* root) {
    // compute postorder
    // dfs and reverse
    unordered_set<BasicBlock*> visited_bb;
    vector<BasicBlock*> rpo;//reverse post order
    vector<BasicBlock*> stack;
    stack.push_back(root);
    visited_bb.insert(root);
    unordered_set<BasicBlock*> useless_bb;
    while(!stack.empty()) {
        auto bb = stack.back();
        stack.pop_back();
        rpo.push_back(bb);
        for(auto& succ:bb->succ) {
            if(!visited_bb.count(succ)) {
                stack.push_back(succ);
                visited_bb.insert(succ);
            }
        }
    }
    bool change = false;
    for(int iter = rpo.size()-1;iter>=0;iter--) {
        auto i = rpo[iter];
        auto last_inst = i->get_instrs().back().get();
        Instanceof(br,BranchInstr*,last_inst) {
            if(br->get_bb_2()) { // branch
                if(br->get_bb_2() == br->get_bb_1()) {
                    br->remove_use_def();
                    br->set_bb2(nullptr);
                    br->set_reg(nullptr);
                    change = true;
                } else if(br->get_bb_2()) {
                    if(br->get_reg()->get_id() < 0 ) {
                        auto target_bb = br->get_reg()->get_num().int_num == 0 ? br->get_bb_2():br->get_bb_1();
                        auto expire_bb = br->get_bb_1() == target_bb ? br->get_bb_2() : br->get_bb_1();
                        br->remove_use_def();
                        br->set_reg(nullptr);
                        br->set_bb2(nullptr);
                        br->set_bb1(target_bb);
                        i->succ.erase(expire_bb);
                        expire_bb->prev.erase(i);
                        for(auto &inst_expire:expire_bb->get_instrs()) {
                            Instanceof(phi_expire,PhiInstr*,inst_expire.get()) {
                                if(phi_expire->get_bb_2_value().count(i)) {
                                    phi_expire->remove_use_def();
                                    phi_expire->get_bb_2_value().erase(i);
                                    phi_expire->add_use_def();
                                }
                            } else Instanceof(array_phi_expire,ArrayPhi*,inst_expire.get()) {
                                if(array_phi_expire->get_bb_2_value().count(i)) {
                                    array_phi_expire->remove_use_def();
                                    array_phi_expire->get_bb_2_value().erase(i);
                                    array_phi_expire->add_use_def();
                                }
                            } else break;
                        }
                    }
                }
            }
            if(!br->get_bb_2() && !br->get_reg()){ // jump
                br->remove_use_def();
                auto j = br->get_bb_1();
                if(j->get_id() == 12) {
                    int tmp = 0;
                }
                if(i->get_instrs().size() == 1 && i != root) {
                    // replace transfers to i with transfers to j
                    bool replaceable = true;
                    for(auto &inst_j:j->get_instrs()) {
                        Instanceof(phi_j,PhiInstr*,inst_j.get()) {
                            for(auto &i_prev:i->prev) {
                                if (phi_j->get_bb_2_value().count(i_prev)) {
                                    replaceable = false;
                                    break;
                                }
                            }
                        }
                        else break;
                        if(!replaceable) break;
                    }
                    if(replaceable) {
                        // 此时不能删 phi对i的value
                        for(auto prev:i->prev) {
                            prev->succ.erase(i);
                            prev->succ.insert(j);
                            j->prev.insert(prev);
                            j->prev.erase(i);
                            Instanceof(br_prev,BranchInstr*,prev->get_instrs().back().get()) {
                                if(br_prev->get_bb_1() == i) {
                                    br_prev->set_bb1(j);
                                }
                                if(br_prev->get_bb_2() == i) {
                                    br_prev->set_bb2(j);
                                }
                            }
                            for(auto &inst_j:j->get_instrs()) {
                                Instanceof(phi_j,PhiInstr*,inst_j.get()) {
                                    if(phi_j->get_bb_2_value().count(i)) {
                                        phi_j->get_bb_2_value()[prev] = phi_j->get_bb_2_value()[i];
                                    }
                                } else Instanceof(array_phi,ArrayPhi*,inst_j.get()) {
                                    if(array_phi->get_bb_2_value().count(i)) {
                                        array_phi->get_bb_2_value()[prev] = array_phi->get_bb_2_value()[i];
                                    }
                                }
                                else break;
                            }
                        }
                        for(auto &inst_j:j->get_instrs()) {
                            Instanceof(phi_j,PhiInstr*,inst_j.get()) {
                                if(phi_j->get_bb_2_value().count(i)) {
                                    phi_j->remove_use_def();
                                    phi_j->get_bb_2_value().erase(i);
                                    phi_j->add_use_def();
                                }
                            } else Instanceof(array_phi,ArrayPhi*,inst_j.get()) {
                                if(array_phi->get_bb_2_value().count(i)) {
                                    array_phi->remove_use_def();
                                    array_phi->get_bb_2_value().erase(i);
                                    array_phi->add_use_def();
                                }
                            }
                            else break;
                        }

                        i->prev.clear();
                        i->succ.clear();
                        change = true;
                        continue ;
                    }
                }
                if(j->prev.size() == 1) {
                    // merge j to i
                    // 直接合并就可以了
                    i->succ.erase(j);
                    j->prev.erase(i);
                    i->succ.insert(j->succ.begin(),j->succ.end());
                    // j succ prev modify
                    for(auto &succ:j->succ) {
                        succ->prev.erase(j);
                        succ->prev.insert(i);
                        for(auto &inst:succ->get_instrs()) {
                            Instanceof(phi_succ,PhiInstr*,inst.get()) {
                                if(phi_succ->get_bb_2_value().count(j)) {
                                    phi_succ->get_bb_2_value()[i] = phi_succ->get_bb_2_value()[j];
                                    phi_succ->get_bb_2_value().erase(j);
                                }
                            } else Instanceof(array_phi,ArrayPhi*,inst.get()) {
                                if(array_phi->get_bb_2_value().count(j)) {
                                    array_phi->get_bb_2_value()[i] = array_phi->get_bb_2_value()[j];
                                    array_phi->get_bb_2_value().erase(j);
                                }
                            }
                            else break;
                        }
                    }
                    i->get_instrs().pop_back();
                    // j phi modify
                    for(auto iter_j = j->get_instrs().begin();iter_j != j->get_instrs().end();) {
                        auto &inst = *iter_j;
                        Instanceof(phi_j,PhiInstr*,inst.get()) {
                            if(phi_j->get_bb_2_value().count(i)) {
                                copy_propagation(root->get_belongto_func()->use_place,
                                                 phi_j->get_dst()->get_id(),
                                                 phi_j->get_bb_2_value()[i]);
                                phi_j->remove_use_def();
                                iter_j = j->get_instrs().erase(iter_j);
                            }
                        } else Instanceof(array_phi,ArrayPhi*,inst.get()) {
                            if(array_phi->get_bb_2_value().count(i)) {
                                Instanceof(reg,Reg*,array_phi->get_dst().get()) {
                                    copy_propagation(root->get_belongto_func()->use_place,
                                         array_phi->get_dst()->get_id(),
                                         static_pointer_cast<Reg>(array_phi->get_bb_2_value()[i]));
                                } else Instanceof(vector,Vector*,array_phi->get_dst().get()) {
                                    copy_propagation(root->get_belongto_func()->use_place,
                                             array_phi->get_dst()->get_id(),
                                             static_pointer_cast<Vector>(array_phi->get_bb_2_value()[i]));
                                }
                                array_phi->remove_use_def();
                                iter_j = j->get_instrs().erase(iter_j);
                            }
                        } else {
                            iter_j->get()->set_belongto_bb(i);
                            iter_j++;
                        }
                    }
                    i->get_instrs().splice(i->get_instrs().end(),j->get_instrs()); // splice 之后 j 已经没有指令了
                    j->succ.clear();
                    j->prev.clear();
                    change = true;
                    continue ;
                }
                if(j->get_instrs().size() == 1) {
                    Instanceof(tmp_br,BranchInstr*,j->get_instrs().back().get()) {
                        //overwrite i’s jump with a copy of j’s branch
                        // 解除i,j之间的cfg连接
                        i->succ.erase(j);
                        j->prev.erase(i);

                        // j的 succ 的 phi 重写
                        // j的succ 的 prev 增加
                        for(auto &succ:j->succ) {
                            succ->prev.insert(i);
                            i->succ.insert(succ);
                            for(auto &inst:succ->get_instrs()) {
                                Instanceof(phi_succ,PhiInstr*,inst.get()) {
                                    if(phi_succ->get_bb_2_value().count(j))
                                    phi_succ->get_bb_2_value()[i] = phi_succ->get_bb_2_value()[j];
                                } else Instanceof(array_phi,ArrayPhi*,inst.get()) {
                                    if(array_phi->get_bb_2_value().count(j))
                                    array_phi->get_bb_2_value()[i] = array_phi->get_bb_2_value()[j];
                                }
                                else break;
                            }
                        }
                        // i 的jump 改 br
                        br->set_bb2(tmp_br->get_bb_2());
                        br->set_bb1(tmp_br->get_bb_1());
                        br->set_reg(tmp_br->get_reg());
                        br->add_use_def();
                    }
                    continue ;
                }
            }
        }
    }
    return change;
}

void clean(Function* func) {
    while(one_pass(func->get_bbs().front().get())) {}
}

void useless_cf_remove(CompileUnit* compileUnit) {
    for(auto &func:compileUnit->get_functions()) {
        if(func->is_lib() || func->get_bbs().empty())
            continue ;
        Factory::reset(func.get());
        clean(func.get());
        func->set_bb_max_num(Factory::bb_num);
        func->set_reg_max_num(Factory::reg_num);
    }

}

};