//
// Created by 11069 on 20/7/2023.
//

#include "opt.h"

using namespace Ir;
namespace opt {

static void dfs(Function* func) {
    func->visited = true;
    for(auto &bb:func->get_bbs()) {
        for(auto &inst:bb->get_instrs()) {
            Instanceof(call,CallInstr*,inst.get()) {
                if(!call->get_function()->visited)
                    dfs(call->get_function());
            }
        }
    }
}

void useless_func_clean(CompileUnit* compileUnit) {
    Function* main_func;
    for(auto &func:compileUnit->get_functions()) {
        func->visited = false;
        if(func->get_name() == "main") {
            main_func = func.get();
        }
        if(func->get_name() == memset_func_name) {
            func->visited = true;
        }
    }

    dfs(main_func);

    for(auto iter = compileUnit->get_functions().begin();iter != compileUnit->get_functions().end();) {
        auto func = iter->get();
        if(!func->visited) {
            iter = compileUnit->get_functions().erase(iter);
            continue ;
        }
        iter ++;
    }
}

}