//
// Created by 11067 on 2023/7/3.
//

#ifndef COMPILER_BITUTILS_H
#define COMPILER_BITUTILS_H

#include <cstring>

inline unsigned int toUI32(int num) {
    unsigned int ret;
    std::memcpy(&ret, &num, sizeof(int));
    return ret;
}

inline unsigned int toUI32(float num) {
    unsigned int ret;
    std::memcpy(&ret, &num, sizeof(float));
    return ret;
}

inline int getHi16(int num) {
    return static_cast<int>((toUI32(num) & 0xffff0000) >> 16);
}
inline bool isImm16(int num) {
    return (toUI32(num) & 0xffff0000) == 0;
}

inline int getLo16(int num) {
    return static_cast<int>(toUI32(num) & 0x0000ffff);
}

inline int calcCLZ(int n) {
    int ret = 0;
    auto un = toUI32(n);
    un >>= 1;
    while (un != 0) {
        un >>=1;
        ret++;
    }
    return ret;
}

inline bool isPow2(int n) {
    auto t = toUI32(n);
    return (t & (t-1)) == 0;
}

#endif //COMPILER_BITUTILS_H
