//
// Created by shliba on 2023/6/20.
//

#ifndef COMPILER_UTILS_H
#define COMPILER_UTILS_H

#include <iostream>
#include <vector>

#define Instanceof(res, type, var) if (auto res = dynamic_cast<type>(var))
#define EPS 10e-20
#define panic(hint) \
    do {                \
    std::cerr<<"\x1b[91mpanic:"<<__FILE__<<':'<<__LINE__<<' '<<(hint)<<"\x1b[0m\n"; \
    std::exit(-1);  \
    } while(0)

#define unimplemented() panic("unimplemented")


#define unreachable()   panic("unreachable")


#define atriAssert(cond) if(!(cond)) {panic("assert failed: "#cond);}

//template<typename T>
//inline void removeFromVec(std::vector<T> &vec, T what) {
//    auto newEnd = std::remove(vec.begin(), vec.end(),what);
//    vec.erase(newEnd, vec.end());
//}
//template <typename T>
//std::ostream & operator<<(std::ostream &out, const std::vector<T> &vec) {
//    out << '[';
//    for (auto &elem: vec) {
//        out << elem << ",";
//    }
//    out << ']';
//    return out;
//}


#endif // COMPILER_UTILS_H
